%define pkgname      wxpython4
%define srcname      wxPython

%bcond_without tests

# Build currently broken with Doxygen >= 1.9.7
%bcond_with dox

# wxWidgets version
%global wxversion 3.2.0

# comment out if not a pre-release
#global prel	a1

# comment out if not a snapshot
#global	snap	dev5449+3ac1e526

# release
%global rel	2

Name:           python-wxpython4
Version:        4.2.0
Release:        %mkrel %{?prel:0.%prel.}%{?snap:%snap.}%{rel}
Summary:        New implementation of wxPython, a GUI toolkit for Python
# wxPython is licensed under the wxWidgets license.  The only exception is
# the pubsub code in wx/lib/pubsub which is BSD licensed.  Note: wxPython
# includes a bundled copy of wxWidgets in ext/wxWidgets which has a few
# bits of code that use other licenses.  This source is not used in the
# Fedora build, except for the interface headers in ext/wxWidgets/interface
# and the doxygen build scripts.
License:        wxWidgets and BSD
Group:          Development/Python
URL:            https://www.wxpython.org/
%if 0%{?snap:1}
Source0:	https://wxpython.org/Phoenix/snapshot-builds/wxPython-%{version}%{?prel}%{?snap:.%snap}.tar.gz
%else
Source0:	https://files.pythonhosted.org/packages/source/w/%{srcname}/%{srcname}-%{version}.tar.gz
%endif
Source1:	https://github.com/wxWidgets/wxWidgets/releases/download/v%{wxversion}/wxWidgets-%{wxversion}.tar.bz2
Patch51:	nanosvg-linking.patch
BuildRequires:  gcc-c++
BuildRequires:  doxygen
BuildRequires:  waf >= 2.0.18-2
BuildRequires:  wxgtk-devel >= 3.2.0
# For tests
%if %{with tests}
BuildRequires:  locales-en
BuildRequires:  x11-server-xvfb
BuildRequires:  python3-numpy
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-timeout
BuildRequires:  python3-pytest-xdist
%endif

%description
wxPython4 is a is a new implementation of wxPython focused on improving speed,
maintainability and extensibility. Just like "Classic" wxPython it wraps the
wxWidgets C++ toolkit and provides access to the user interface portions of the
wx API, enabling Python applications to have a GUI on Windows, Macs or Unix
systems with a native look and feel and requiring very little (if any) platform
specific code.
#----------------------------------------------

### Python 3

%package -n     python3-%{pkgname}
Summary:        New implementation of wxPython, a GUI toolkit for Python3
Group:          Development/Python
%{?python_provide:%python_provide python3-%{pkgname}}
BuildRequires:  python3-devel
BuildRequires:  python3-numpy-devel
BuildRequires:  python3-pillow
BuildRequires:  python3-requests
BuildRequires:  python3-setuptools
BuildRequires:  python3-sip6
BuildRequires:  python3-six
BuildRequires:  python3-attrdict
Requires:       python3-pillow
Requires:       python3-six

%description -n python3-%{pkgname}
wxPython4 is a is a new implementation of wxPython focused on improving speed,
maintainability and extensibility. Just like "Classic" wxPython it wraps the
wxWidgets C++ toolkit and provides access to the user interface portions of the
wx API, enabling Python applications to have a GUI on Windows, Macs or Unix
systems with a native look and feel and requiring very little (if any) platform
specific code.

#----------------------------------------------

%package -n     python3-%{pkgname}-media
Summary:        New implementation of wxPython, a GUI toolkit for Python3 (media module)
Group:          Development/Python
%{?python_provide:%python_provide python3-%{pkgname}-media}
Requires:       python3-%{pkgname} = %{version}-%{release}

%description -n python3-%{pkgname}-media
wxPython4 is a is a new implementation of wxPython focused on improving speed,
maintainability and extensibility. Just like "Classic" wxPython it wraps the
wxWidgets C++ toolkit and provides access to the user interface portions of the
wx API, enabling Python applications to have a GUI on Windows, Macs or Unix
systems with a native look and feel and requiring very little (if any) platform
specific code.

This package provides the wx.media module.

%package -n     python3-%{pkgname}-webview
Summary:        New implementation of wxPython, a GUI toolkit for Python3 (webview module)
Group:          Development/Python
%{?python_provide:%python_provide python3-%{pkgname}-webview}
Requires:       python3-%{pkgname} = %{version}-%{release}

%description -n python3-%{pkgname}-webview
wxPython4 is a is a new implementation of wxPython focused on improving speed,
maintainability and extensibility. Just like "Classic" wxPython it wraps the
wxWidgets C++ toolkit and provides access to the user interface portions of the
wx API, enabling Python applications to have a GUI on Windows, Macs or Unix
systems with a native look and feel and requiring very little (if any) platform
specific code.

This package provides the wx.html2 module.

%package        doc
Summary:        Documentation and samples for wxPython
Group:          Development/Python
BuildArch:      noarch

%description doc
Documentation, samples and demo application for wxPython.

#----------------------------------------------

%prep
%autosetup -n %{srcname}-%{version}%{?prel}%{?snap:.%snap} -p1 -a1

rm -rf sip/siplib
rm -rf wx/py/tests
rm -f docs/sphinx/_downloads/i18nwxapp/i18nwxapp.zip
cp -a wx/lib/pubsub/LICENSE_BSD_Simple.txt license
# Remove env shebangs from various files
sed -i -e '/^#!\//, 1d' demo/*.py{,w}
sed -i -e '/^#!\//, 1d' demo/agw/*.py
sed -i -e '/^#!\//, 1d' docs/sphinx/_downloads/i18nwxapp/*.py
sed -i -e '/^#!\//, 1d' samples/floatcanvas/*.py
sed -i -e '/^#!\//, 1d' samples/mainloop/*.py
sed -i -e '/^#!\//, 1d' samples/ribbon/*.py
sed -i -e '/^#!\//, 1d' wx/py/*.py
sed -i -e '/^#!\//, 1d' wx/tools/*.py
# Fix end of line encodings
sed -i 's/\r$//' docs/sphinx/_downloads/*.py
sed -i 's/\r$//' docs/sphinx/rest_substitutions/snippets/python/contrib/*.py
sed -i 's/\r$//' docs/sphinx/rest_substitutions/snippets/python/converted/*.py
sed -i 's/\r$//' docs/sphinx/_downloads/i18nwxapp/locale/I18Nwxapp.pot
sed -i 's/\r$//' docs/sphinx/make.bat
sed -i 's/\r$//' docs/sphinx/phoenix_theme/theme.conf
sed -i 's/\r$//' samples/floatcanvas/BouncingBall.py
# Remove spurious executable perms
chmod -x demo/*.py
chmod -x samples/mainloop/mainloop.py
chmod -x samples/printing/sample-text.txt
# Remove empty files
find demo -size 0 -delete
find docs/sphinx/rest_substitutions/snippets/python/converted -size 0 -delete
# Convert files to UTF-8
for file in demo/TestTable.txt docs/sphinx/_downloads/i18nwxapp/locale/I18Nwxapp.pot docs/sphinx/class_summary.pkl docs/sphinx/wx.1moduleindex.pkl; do
    iconv -f ISO-8859-1 -t UTF-8 -o $file.new $file && \
    touch -r $file $file.new && \
    mv $file.new $file
done

%if 0%{?prel:1} || 0%{?snap:1}
# Update wxWidgets sources
rm -rf ext/wxWidgets
ln -sf $(pwd)/wxWidgets-%{wxversion} ext/wxWidgets
%endif

# Update Doxyfile
doxygen -u $(find . -name "Doxyfile*")

%build
DOXYGEN='%{_bindir}/doxygen' WAF='%{_bindir}/waf' \
%{__python3} -u build.py %{?with_dox:dox touch etg} --nodoc sip build_py --use_syswx --gtk3

%install
%{__python3} build.py install_py --destdir=%{buildroot}
rm -f %{buildroot}%{_bindir}/*
# Remove locale files (they are provided by wxWidgets)
rm -rf %{buildroot}%{python3_sitearch}/wx/locale

%check
%if %{with tests}
SKIP_TESTS="'not (display_Tests or glcanvas_Tests or mousemanager_Tests or numdlg_Tests or uiaction_MouseTests or uiaction_KeyboardTests or unichar_Tests or valtext_Tests or test_frameRestore or test_grid_pi)'"
ln -sf %{python3_sitearch}/wx/siplib.so wx/siplib.so
xvfb-run -a %{__python3} build.py test --pytest_timeout=60 --extra_pytest="-k $SKIP_TESTS" --verbose || true
%endif

%files -n python3-%{pkgname}
%license license/*
%{python3_sitearch}/*
%exclude %{python3_sitearch}/wx/*html2*
%exclude %{python3_sitearch}/wx/__pycache__/*html2*
%exclude %{python3_sitearch}/wx/*media*
%exclude %{python3_sitearch}/wx/__pycache__/*media*

%files -n python3-%{pkgname}-media
%{python3_sitearch}/wx/*media*
%{python3_sitearch}/wx/__pycache__/*media*

%files -n python3-%{pkgname}-webview
%{python3_sitearch}/wx/*html2*
%{python3_sitearch}/wx/__pycache__/*html2*

%files doc
%doc docs demo samples
%license license/*


%changelog
* Sat Jun 24 2023 wally <wally> 4.2.0-2.mga9
+ Revision: 1962991
- skip doxygen build parts for now due to a broken build with doxygen >= 1.9.7

* Tue Aug 09 2022 wally <wally> 4.2.0-1.mga9
+ Revision: 1876338
- new version 4.2.0

* Tue Jul 19 2022 wally <wally> 4.2.0-0.a1.dev5449+3ac1e526.1.mga9
+ Revision: 1869459
- new dev snapshot 4.2.0a1.dev5449+3ac1e526
- build against wxgtk 3.2.0

* Sun Jun 12 2022 wally <wally> 4.1.2~a1^dev5434+7d45ee6a-1.mga9
+ Revision: 1864072
- new snapshot build 4.1.2a1.dev5434+7d45ee6a
- build with wxgtk 3.1.7 and upcoming sip6 6.6.2

* Thu May 12 2022 wally <wally> 4.1.2~a1^dev5330+3e6be81d-1.mga9
+ Revision: 1857785
- new snapshot-build 4.1.2a1.dev5330+3e6be81d

* Fri Apr 29 2022 wally <wally> 4.1.2~a1^dev5310+af8cca51-2.mga9
+ Revision: 1855134
- add more patches from upstream pull request for wxWidgets 3.1.6 support

* Thu Apr 28 2022 wally <wally> 4.1.2~a1^dev5310+af8cca51-1.mga9
+ Revision: 1854927
- update to latest snapshot-build 4.1.2a1.dev5310+af8cca51 with patches from upstream pull request to fix build with wxWidgets 3.1.6
- add patch to fix build with new doxygen
- rebuild for wxgtk 3.1.6

* Wed Apr 06 2022 umeabot <umeabot> 4.1.1-9.mga9
+ Revision: 1845989
- Mageia 9 Mass Rebuild

* Sat Feb 12 2022 tv <tv> 4.1.1-8.mga9
+ Revision: 1773678
- Rebuild for python-3.10

* Sat Jan 15 2022 wally <wally> 4.1.1-7.mga9
+ Revision: 1768508
- rebuild for wxgtk 3.1.5 with working wxSizer::SetSizeHints()

* Tue Jan 04 2022 wally <wally> 4.1.1-6.mga9
+ Revision: 1766834
- rebuild again for wxgtk 3.1.5 without wxGLCanvas Wayland/EGL backend support

* Mon Jan 03 2022 wally <wally> 4.1.1-5.mga9
+ Revision: 1766413
- rebuild for wxgtk 3.1.5 with wxGLCanvas Wayland/EGL backend enabled

* Sat Jan 01 2022 wally <wally> 4.1.1-4.mga9
+ Revision: 1765734
- rebuild for wxgtk 3.1.5 to resolve 'Symbol X has different size in shared object, consider re-linking' error

* Thu Oct 14 2021 ns80 <ns80> 4.1.1-3.mga9
+ Revision: 1751368
- rebuild for new wxgtk3.1

* Mon Mar 15 2021 wally <wally> 4.1.1-2.mga9
+ Revision: 1703631
- add patch to fix linking
- rebuild for python 3.9

* Fri Jan 01 2021 wally <wally> 4.1.1-1.mga8
+ Revision: 1667682
- new version 4.1.1
- switch to wxgtk3.1
+ daviddavid <daviddavid>
- backport upstream fix for wxPseudoDC.FindObjects crash
- backport upstream fix for wxCustomDataObject.GetData crash
- fix FTBFS with sip 4.19.23
- remove BR on python3-pathlib2 (not needed)

* Mon Feb 17 2020 umeabot <umeabot> 4.0.7-2.mga8
+ Revision: 1537115
- Mageia 8 Mass Rebuild

* Sat Oct 26 2019 daviddavid <daviddavid> 4.0.7-1.mga8
+ Revision: 1455832
- new version: 4.0.7
- fix dependency for python3-wx-siplib-api

* Wed Oct 02 2019 tv <tv> 4.0.6-5.mga8
+ Revision: 1448864
- fix deps

* Fri Sep 27 2019 tv <tv> 4.0.6-4.mga8
+ Revision: 1447671
- kill no more needed stuff
- Fix FloatCanvas with Python 3.8 (time.clock removed)
- use %%autosetup
- Switch to using private sip module, wx.siplib (rhbz#1739469)
- adjust BRs

* Sun Sep 15 2019 wally <wally> 4.0.6-3.mga8
+ Revision: 1441404
- build with system waf

* Sun Sep 15 2019 daviddavid <daviddavid> 4.0.6-2.mga8
+ Revision: 1441060
- rebuild for python3.8
- drop python2 support

* Wed Jul 17 2019 daviddavid <daviddavid> 4.0.6-1.mga8
+ Revision: 1422156
- new version: 4.0.6

* Sat Apr 20 2019 daviddavid <daviddavid> 4.0.4-1.mga7
+ Revision: 1393669
- initial package python-wxpython4

